Please note: This project is no longer active. The website is kept online for historic purposes only.
If you´re looking for a Linux driver for your Atheros WLAN device, you should continue here .

Ticket #1323 (new defect)

Opened 15 years ago

Last modified 14 years ago

Short range issue with AR5005G

Reported by: kknuut@paju.oulu.fi Assigned to:
Priority: minor Milestone:
Component: madwifi: driver Version: trunk
Keywords: range AR5005G Cc:
Patch is attached: 0 Pending:

Description

I can only connect to accesspoint within about 3 metres. I have have the same problem with public accesspoint, my home DI-524 wlanrouter and at least one buffalo ap, model unknown. Another laptop with same wlan card works perfectly in windows, and so did my laptop while I still had windows xp.. So im quite sure that the madwifi driver is the issue.

My laptop is Fujitsu-Siemens Amilo 1650G and I'm using Gentoo linux.

My lspci -v:

02:05.0 Ethernet controller: Atheros Communications, Inc. AR5005G 802.11abg NIC (rev 01)
        Subsystem: Atheros Communications, Inc. Compex Wireless 802.11 b/g  MiniPCI Adapter, Rev A1 [WLM54G]
        Flags: bus master, medium devsel, latency 168, IRQ 16
        Memory at d0200000 (32-bit, non-prefetchable) [size=64K]
        Capabilities: [44] Power Management version 2

My first quess was that the problem is TX-power, because I can listen packets with ethereal from normal wlan ranges. And I can scan ap:s in normal ranges. I have tried several madwifi-ng driver versions, and madwifi-old-openhall, none working outside about 3m range.

Version 1.9.3 does not work any better than the latest snapshot, actually i have problems with wlan_scan_sta and ath_rate_sample not loading correctly at first with the 1.9.3. Couple of the latests snapshots do load those with first shot (r2339 doesn't load at first try, but r2345 does). Thus I don't include any prints from the 1.9.3 driver. Ticket is getting rather long already with current prints.

svn r2350

latest snapshot. driver is loaded with rfkill=0

#modprobe ath_pci rfkill=0 && dmesg
ath_pci: 0.9.4.5 (svn r2350)
ACPI: PCI Interrupt 0000:02:05.0[A] -> GSI 20 (level, low) -> IRQ 16
ath_pci: switching rfkill capability off
wifi0: 11b rates: 1Mbps 2Mbps 5.5Mbps 11Mbps
wifi0: 11g rates: 1Mbps 2Mbps 5.5Mbps 11Mbps 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi0: H/W encryption support: WEP AES AES_CCM TKIP
wifi0: mac 7.8 phy 4.5 radio 5.6
wifi0: Use hw queue 1 for WME_AC_BE traffic
wifi0: Use hw queue 0 for WME_AC_BK traffic
wifi0: Use hw queue 2 for WME_AC_VI traffic
wifi0: Use hw queue 3 for WME_AC_VO traffic
wifi0: Use hw queue 8 for CAB traffic
wifi0: Use hw queue 9 for beacons
wifi0: Atheros 5212: mem=0xd0200000, irq=16
# iwlist ath0 txpower
ath0      8 available transmit-powers :
          0 dBm         (1 mW)
          4 dBm         (2 mW)
          6 dBm         (3 mW)
          8 dBm         (6 mW)
          10 dBm        (10 mW)
          12 dBm        (15 mW)
          14 dBm        (25 mW)
          16 dBm        (39 mW)
          Current Tx-Power:16 dBm       (39 mW)
#iwconfig ath0
ath0      IEEE 802.11g  ESSID:"Knuuttila"  Nickname:""
          Mode:Managed  Frequency:2.437 GHz  Access Point: 00:17:9A:5C:20:C9   
          Bit Rate:36 Mb/s   Tx-Power:16 dBm   Sensitivity=0/3  
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=62/94  Signal level=-34 dBm  Noise level=-96 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

iwconfig taken when ap was just beside laptop.

#athstats
16 tx management frames
4 long on-chip tx retries
14 tx frames with no ack marked
5 tx frames with short preamble
2 tx frames with an alternate rate
10588 PHY errors
    638 OFDM timing
    9950 CCK timing
275 periodic calibrations
rssi of last ack: 58
rssi of last rcv: 71
2 switched default/rx antenna
Antenna profile:
[1] tx        1 rx      622
[2] tx        4 rx     2073

PHY errors seem to increase about 30-40 per second. Moving out of "3m range" doesn't affect to their rate.

Next taken after about 2min. I was pinging accesspoint to see when I'm out of range. Pings didn't affect to the rate of PHY errors either.

51 tx management frames
9 tx failed due to too many retries
132 long on-chip tx retries
42 tx frames with no ack marked
73 tx frames with short preamble
19 tx frames with an alternate rate
122 rx failed due to bad CRC
30810 PHY errors
    2916 OFDM timing
    27894 CCK timing
770 periodic calibrations
rssi of last ack: 69
34 switched default/rx antenna
Antenna profile:
[1] tx       10 rx     1003
[2] tx       25 rx     6596

Wattage also seems rather small to me. So i tried to hack the driver code to get bigger tx power:

svn r2345 hacked

This is also loaded with rfkill=0
I changed in function ath_update_txpow(struct ath_softc *sc)
line: (void)ath_hal_getmaxtxpow(ah, &maxtxpowlimit);
to: (void)ath_hal_gettxpowlimit(ah, &maxtxpowlimit);
This as i understand should give me max tx power card can offer and ignore country restrictions. Homever i'm not sure if it's only fooling the output from driver and HAL is still restricting my txpower. (I don't have means to measure actual power) Anyway it gave me following txpowers:

# iwlist ath0 txpower
ath0      8 available transmit-powers :
          0 dBm         (1 mW)
          7 dBm         (5 mW)
          11 dBm        (12 mW)
          15 dBm        (31 mW)
          19 dBm        (79 mW)
          23 dBm        (199 mW)
          27 dBm        (501 mW)
          31 dBm        (1258 mW)
          Current Tx-Power:31 dBm       (1258 mW)

Over 1 watt! Huh, pretty high. Anyway didn't get any better range, so it can't be real output power, or the problem is somewhere else than with the txpower setting.

madwifi-old-openhal r2292

This driver gives me higher txpowers out of the box, but i cannot transmit any data. "Tx excessive retries" at the iwconfig keeps counting up...

Tried to load this driver for printouts, but ran into "unknown symbol" problem this time... Driver used to work at least =) And when it did it gave me max txpower of 100mW.

Conclusion

It seems that these are not real txpower ratings, or the problem lies somewhere else. At least there was no increase in the connection range with any of the drivers I have tried. I have no idea if the PHY errors are related to this, it's still pending deeper investigation.

Snapshots I've tried: 2316, 2339, 2345, 2350, openhall:2292, + couple of older -ng snapshots, which I don't remember.

So I loose the connection after RSSI drops below 50. And even at about 50 it's already pretty unstable. And as I said, this happens at the huge 3 meters range.

Change History

(in reply to: ↑ description ) 05/21/07 07:02:08 changed by mrenzmann

Replying to kknuut@paju.oulu.fi:

I can only connect to accesspoint within about 3 metres.

Double-check that the antenna cables are still properly connected to the jacks on the card.

Link Quality=62/94 Signal level=-34 dBm Noise level=-96 dBm
...
PHY errors seem to increase about 30-40 per second. Moving out of "3m range" doesn't affect to their rate.

That (and the whole issue you describe in your ticket) could also be related to FAQ/SignalTooStrong.

05/28/07 10:11:54 changed by kknuut@paju.oulu.fi

Antenna cables were connectected ok. And I don't see how the signal could be too strong, because then it should work from further apart, which it doesn't. As I said, it works inside 3 meter circle.

(follow-up: ↓ 5 ) 05/28/07 13:02:42 changed by strasak@bubakov.net

PHY errors, from my experience, are usually caused either by overal conditions - interference - or some HW fault - unalligned antennas, defective HW, short-circuit in connectors, etc. etc.. But in your case it really looks like driver issue. Anyway, i would try to change channel on AP and to set diversity off and set fixed TX and RX antenna. Also, this is pretty strange :

30810 PHY errors
    2916 OFDM timing
    27894 CCK timing
770 periodic calibrations
rssi of last ack: 69
34 switched default/rx antenna
Antenna profile:
[1] tx       10 rx     1003
[2] tx       25 rx     6596

What kind of stuff is it receiving ?

06/04/07 22:07:03 changed by kknuut@paju.oulu.fi

I tried diversity off and played with antennas, but I think range got only worse. This was with now newest svn version r2427.

But I didn't get PHY errors at all now according to athstats. I checked with r2345 and PHY errors were back, even when not associated with ap yet. So something is fixed between r2345 <-> r2427.

Too bad range issue is still there. On side note, I don't know if these could be linked, but when first modprobing ath_pci, it doesn't auto load ath_rate_sample and wlan_scan_sta. when manually probing them and then removing and loading ath_pci again things start to work ( scanning ).

(in reply to: ↑ 3 ) 06/05/07 13:01:17 changed by kknuut@paju.oulu.fi

Replying to strasak@bubakov.net:

{{{ 30810 PHY errors 2916 OFDM timing 27894 CCK timing 770 periodic calibrations rssi of last ack: 69 34 switched default/rx antenna Antenna profile: [1] tx 10 rx 1003 [2] tx 25 rx 6596 }}} What kind of stuff is it receiving ?

I was pinging wlan router from the laptop

10/22/07 14:05:10 changed by anonymous

I can confirm this range issue. Immediately after connecting I get a connection speed of 54 Mbps which then quickly drops to as low as 2 Mbps when I actually send and receive data, which is some kind of a bottleneck for my 26 Mbps internet connection. Link quality is around 32/70, signal level -61 dBm, Noise level -93 dBm. The AP is about 3 meters away in direct line of sight. Other NICs work well with this AP, also my AR5005G card does work well with Windows drivers. I am using version 0.9.3.2 of the drivers. It would be nice if you could look into this issue, I will help whereever possible.

04/02/08 14:56:21 changed by toraias(at)gmial.com

same card, same problem ;/